/* Copyright 2020-2025, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <vectorwrapper/vectorwrapper.hpp>
#include <QPoint>
#include <cstddef>

namespace duck::detail {
struct VecSimpleXYPoint { int x, y; };
} //namespace duck::detail

namespace vwr {
template <>
struct VectorWrapperInfo<QPoint> {
	enum { dimensions = 2 };
	typedef int scalar_type;
	typedef QPoint vector_type;

	static_assert(sizeof(duck::detail::VecSimpleXYPoint) == sizeof(QPoint), "Unexpected QPoint size, maybe you will have to provide get_at()");
	enum {
		offset_x = offsetof(duck::detail::VecSimpleXYPoint, x),
		offset_y = offsetof(duck::detail::VecSimpleXYPoint, y)
	};
};
} //namespace vwr

namespace duck {
typedef vwr::Vec<QPoint> qtint2;
} //namespace duck
